summaryrefslogtreecommitdiff
path: root/dev-python/pyopencl
diff options
context:
space:
mode:
authorroot <root@alpha.trunkmasters.com>2026-06-04 05:48:38 -0500
committerroot <root@alpha.trunkmasters.com>2026-06-04 05:48:38 -0500
commitbfd9c39e4712ebdb442d4ca0673061faed1e70e1 (patch)
tree0d7a74b4463ee387f9cf9368ceb1b757f694f72a /dev-python/pyopencl
parentf716a9fe6455d39eef01e718aae68dae61c19704 (diff)
downloadbaldeagleos-repo-bfd9c39e4712ebdb442d4ca0673061faed1e70e1.tar.gz
baldeagleos-repo-bfd9c39e4712ebdb442d4ca0673061faed1e70e1.tar.xz
baldeagleos-repo-bfd9c39e4712ebdb442d4ca0673061faed1e70e1.zip
Revert "Adding metadata"
This reverts commit f716a9fe6455d39eef01e718aae68dae61c19704.
Diffstat (limited to 'dev-python/pyopencl')
-rw-r--r--dev-python/pyopencl/Manifest2
-rw-r--r--dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch21
-rw-r--r--dev-python/pyopencl/files/pyopencl-2025.1-numpy-build.patch50
-rw-r--r--dev-python/pyopencl/metadata.xml9
-rw-r--r--dev-python/pyopencl/pyopencl-2025.1.ebuild82
5 files changed, 164 insertions, 0 deletions
diff --git a/dev-python/pyopencl/Manifest b/dev-python/pyopencl/Manifest
new file mode 100644
index 000000000000..ef62cfaeeb56
--- /dev/null
+++ b/dev-python/pyopencl/Manifest
@@ -0,0 +1,2 @@
+DIST pyopencl-2025.1.tar.gz 422510 BLAKE2B 1da270b4eabd3cf1209c97db6383ccd3450601946181386c139ed76b9cee3cccba06d6836b342b902fb227d1ef43f899633fe2037f5744a38b37677ef70ed00c SHA512 bc281c38b977f207a213763aca3c0086430e5a4d8d9018673fb5648e1afc440758ec7ec219544644d596805beaa448b2fa34cd5b4c109a46b3d6e8b7648a931c
+DIST pyopencl-2025.1.tar.gz.provenance 9183 BLAKE2B 3114192e2e2bcaa202230e2e55245086a020086d09db0ba14c5b48a70bde09defc4d8d1697bc33978fd5b4b6fc902330414078f9ee43aced3d3243392006b3f1 SHA512 7129b058dee923815b487331a7cd29128f88e23feed8c0dfad4d8663bd20575b9f16f22bd97b55d6109d2dfdd2871c899687097b9b2cbb89c816ec27cb555be2
diff --git a/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch b/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch
new file mode 100644
index 000000000000..6f7c7cff1462
--- /dev/null
+++ b/dev-python/pyopencl/files/pyopencl-2025.1-nanobind-flags.patch
@@ -0,0 +1,21 @@
+nanobind defaults to adding -Os and friends: https://github.com/wjakob/nanobind/blob/b0136fe6ac1967cb2399456adc346a1af06a3b88/docs/api_cmake.rst#L80.
+
+... and LTO should be user defined via cflags.
+
+--- a/CMakeLists.txt
+diff --git a/CMakeLists.txt b/CMakeLists.txt
+index 4557bd8a..0f4a731c 100644
+--- a/CMakeLists.txt
++++ b/CMakeLists.txt
+@@ -167,8 +167,9 @@ find_package(OpenCL REQUIRED)
+ nanobind_add_module(
+ _cl
+ NB_STATIC # Build static libnanobind (the extension module itself remains a shared library)
+- LTO
++ PROTECT_STACK
+ NOMINSIZE
++ NOSTRIP
+ src/wrap_constants.cpp
+ src/wrap_cl.cpp
+ src/wrap_cl_part_1.cpp
+
diff --git a/dev-python/pyopencl/files/pyopencl-2025.1-numpy-build.patch b/dev-python/pyopencl/files/pyopencl-2025.1-numpy-build.patch
new file mode 100644
index 000000000000..1d912ba4b7dc
--- /dev/null
+++ b/dev-python/pyopencl/files/pyopencl-2025.1-numpy-build.patch
@@ -0,0 +1,50 @@
+https://bugs.gentoo.org/957615
+https://github.com/inducer/pyopencl/commit/a56381055c6b4a75d69f62be82a4b72ee6d1d7ab
+
+From a56381055c6b4a75d69f62be82a4b72ee6d1d7ab Mon Sep 17 00:00:00 2001
+From: Thomas A Caswell <tcaswell@bnl.gov>
+Date: Wed, 12 Feb 2025 16:52:52 -0500
+Subject: [PATCH] MNT: stop using deprecated numpy macros
+
+These were deprecated in np1.7 and will be removed in np2.3 (currently removed
+on numpy main branch).
+
+xref https://github.com/numpy/numpy/pull/28254/
+---
+ src/wrap_cl.hpp | 4 ++--
+ src/wrap_helpers.hpp | 4 ++--
+ 2 files changed, 4 insertions(+), 4 deletions(-)
+
+diff --git a/src/wrap_cl.hpp b/src/wrap_cl.hpp
+index 5b225d3cd..d61f3d546 100644
+--- a/src/wrap_cl.hpp
++++ b/src/wrap_cl.hpp
+@@ -5893,9 +5893,9 @@ namespace pyopencl
+
+ int ary_flags = 0;
+ if (order == NPY_FORTRANORDER)
+- ary_flags |= NPY_FARRAY;
++ ary_flags |= NPY_ARRAY_FARRAY;
+ else if (order == NPY_CORDER)
+- ary_flags |= NPY_CARRAY;
++ ary_flags |= NPY_ARRAY_CARRAY;
+ else
+ throw std::runtime_error("unrecognized order specifier");
+
+diff --git a/src/wrap_helpers.hpp b/src/wrap_helpers.hpp
+index 367749535..041065930 100644
+--- a/src/wrap_helpers.hpp
++++ b/src/wrap_helpers.hpp
+@@ -142,9 +142,9 @@ namespace py = nanobind;
+ \
+ int ary_flags = 0; \
+ if (order == NPY_FORTRANORDER) \
+- ary_flags |= NPY_FARRAY; \
++ ary_flags |= NPY_ARRAY_FARRAY; \
+ else if (order == NPY_CORDER) \
+- ary_flags |= NPY_CARRAY; \
++ ary_flags |= NPY_ARRAY_CARRAY; \
+ else \
+ throw std::runtime_error("unrecognized order specifier"); \
+ \
+
diff --git a/dev-python/pyopencl/metadata.xml b/dev-python/pyopencl/metadata.xml
new file mode 100644
index 000000000000..f759654cf43b
--- /dev/null
+++ b/dev-python/pyopencl/metadata.xml
@@ -0,0 +1,9 @@
+<?xml version="1.0" encoding="UTF-8"?>
+<!DOCTYPE pkgmetadata SYSTEM "https://www.gentoo.org/dtd/metadata.dtd">
+<pkgmetadata>
+ <!-- maintainer-needed -->
+ <upstream>
+ <remote-id type="pypi">pyopencl</remote-id>
+ <remote-id type="github">inducer/pyopencl</remote-id>
+ </upstream>
+</pkgmetadata>
diff --git a/dev-python/pyopencl/pyopencl-2025.1.ebuild b/dev-python/pyopencl/pyopencl-2025.1.ebuild
new file mode 100644
index 000000000000..c9e8807ba183
--- /dev/null
+++ b/dev-python/pyopencl/pyopencl-2025.1.ebuild
@@ -0,0 +1,82 @@
+# Copyright 1999-2026 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+DISTUTILS_EXT=1
+DISTUTILS_USE_PEP517=scikit-build-core
+PYPI_VERIFY_REPO=https://github.com/inducer/pyopencl
+PYTHON_COMPAT=( python3_{13..14} )
+
+inherit distutils-r1 multiprocessing pypi
+
+DESCRIPTION="Python wrapper for OpenCL"
+HOMEPAGE="
+ https://mathema.tician.de/software/pyopencl/
+ https://github.com/inducer/pyopencl/
+ https://pypi.org/project/pyopencl/
+"
+
+LICENSE="GPL-2"
+SLOT="0"
+KEYWORDS="amd64 ~ppc64 ~riscv"
+IUSE="examples opengl"
+
+# Running tests on GPUs requires both appropriate hardware and additional permissions
+# having been granted to the user running them. Testing on CPUs with dev-libs/pocl
+# is in theory possible but has been found to be very fragile, see e.g. Bug #872308.
+RESTRICT="test"
+
+COMMON=">=virtual/opencl-2"
+# libglvnd is only needed for the headers
+DEPEND="
+ ${COMMON}
+ opengl? ( media-libs/libglvnd )
+"
+RDEPEND="
+ ${COMMON}
+ >=dev-python/mako-0.3.6[${PYTHON_USEDEP}]
+ dev-python/numpy[${PYTHON_USEDEP}]
+ >=dev-python/platformdirs-2.2.0[${PYTHON_USEDEP}]
+ >=dev-python/pytools-2024.1.5[${PYTHON_USEDEP}]
+"
+BDEPEND="
+ dev-python/numpy[${PYTHON_USEDEP}]
+ dev-python/nanobind[${PYTHON_USEDEP}]
+ test? ( dev-libs/pocl )
+"
+
+PATCHES=(
+ "${FILESDIR}"/${PN}-2025.1-nanobind-flags.patch
+ "${FILESDIR}"/${P}-numpy-build.patch
+)
+
+EPYTEST_PLUGINS=()
+distutils_enable_tests pytest
+
+python_configure_all() {
+ DISTUTILS_ARGS=(
+ -DPYOPENCL_ENABLE_GL=$(usex opengl)
+ )
+}
+
+python_test() {
+ # Use dev-libs/pocl for testing; ignore any other OpenCL devices that might be present
+ local -x PYOPENCL_TEST="portable:cpu"
+ # Set the number of threads to match MAKEOPTS
+ local -x POCL_MAX_PTHREAD_COUNT=$(makeopts_jobs)
+ # Change to the 'test' directory so that python does not try to import pyopencl from the source directory
+ # (Importing from the source directory fails, because the compiled '_cl' module is only in the build directory)
+ pushd test >/dev/null || die
+ epytest
+ popd >/dev/null || die
+}
+
+python_install_all() {
+ if use examples; then
+ dodoc -r examples
+ docompress -x /usr/share/doc/${PF}/examples
+ fi
+
+ distutils-r1_python_install_all
+}